var fs = require('fs');
//var jsonUtils = require('../../'); //looks for index.js file
var json2jsonPush = require('../../').json2jsonPush; 
var utils = require('../../').utils; 
var nconf = require('nconf');
nconf.file({
	file : 'pushConfig.json'
	//file : 'pushConfigSingle.json'
});

var CONSTANTS = {
		pushSides: {
			from: "from",
			to: "to"
		}
	};

//Use the different pushFrom and PushTo files to test different scenarios
var pushFromJSON = fs.readFileSync('./pushFrom.json');
//var pushFromJSON = fs.readFileSync( './pushFromDocIdArray.json');
//var pushFromJSON = fs.readFileSync( './pushFromDocIdNotArray.json');
//var pushFromJSON = fs.readFileSync( './pushFromNoDocId.json');
//var pushFromJSON = fs.readFileSync('./pushFromSingleField.json');

var pushToJSON = fs.readFileSync('./pushTo.json');
//var pushToJSON = fs.readFileSync( './pushToDocIdArray.json');
//var pushToJSON = fs.readFileSync( './pushToDocIdNotArray.json');
//var pushToJSON = fs.readFileSync( './pushToNoDocId.json');
//var pushToJSON = fs.readFileSync('./pushToSingleField.json');

var pushConfig = nconf.get('pushConfig');

//Only one line of code is needed to call jsonPush. However;
//the call must be surrounded by a try catch so that any validation 
//errors that "jp.jsonPush" can throw can be handled. The parameters
//sent in are the Source JSON, the Target JSON and the Push Configuration.

try {
	
	//var pushToParsedJson = jsonUtils.json2jsonPush.push(pushFromJSON, pushToJSON, pushConfig);
	var pushToParsedJson = json2jsonPush.initiate(pushFromJSON, pushToJSON, pushConfig);
	
	//console.log('Enriched Target JSON:');
	console.log(JSON.stringify(pushToParsedJson));
} catch (err) {
	console.log(err);
	throw err;
}

//jsonPush will automatically run these validations below before allowing itself to run.
//However, these validations can be run separately and apart from the jsp.jsonPush function
//if desired.
/*
try {
	var boolPushConfig = json2jsonPush.validateJson2JsonPushConfiguration(pushConfig);
} catch (err) {
	console.log(err);
	throw err;
}

try {
	var boolReqFrom = json2jsonPush.validateExistenceOfRequiredTargets(pushFromJSON, pushConfig, CONSTANTS.pushSides.from);
	var boolReqTo = json2jsonPush.validateExistenceOfRequiredTargets(pushToJSON, pushConfig, CONSTANTS.pushSides.to);
} catch (err) {
	console.log(err);
	throw err;
}
*/

//initialize Push and ToParent Objects from json2jsonPush

//var toParent = new jsonUtils.json2jsonPush.ToParent(1, 'parentName', [] );
//console.log(JSON.stringify(toParent));

//Using 'utils' functions
//var path = utils.getJSONPath( pushFromJSON, 'nc:Document'); 
//console.log(path);

//var jsonJSPath = utils.createJavaScriptJSONPath(path.toString());                       	
//console.log(jsonJSPath);