var jpath = require('json-path');
var fs = require('fs');
var _ = require('underscore');
var S = require('string');
var traverse = require('traverse');
require('buffertools').extend();

module.exports.createJavaScriptJSONPath =
	function createJavaScriptJSONPath(path) {
	
		var thePath = '';
		var pathArray = path.split(",");		 
		pathArray.forEach(function(data){
			thePath += "['" + data + "']"; 
		});
		
		return thePath;
	};

module.exports.getJSONPath = 
	function getJSONPath (json, property) {	
	
		json = module.exports.parseJSON(json);
	
	    var jsonPath;	
		traverse(json).forEach(
			 function to_s(node) {					
				var key = S(this.key).toString();
				if (key && _.isEqual(key, property )) {
					jsonPath = this.path;
				}								
			}	
		);	
	    
	    return jsonPath;		
	};
	
module.exports.parseJSON = 
	function parseJSON (json) {	
		
		var parsedJson;	
		try  {
			parsedJson = JSON.parse(json);
		} catch (e) {
			parsedJson = json;
		}
			
		return parsedJson;	
	}
